"{ Package: 'stx:goodies/monticello' }"

MCDefinition subclass:#MCScriptDefinition
	instanceVariableNames:'script packageName'
	classVariableNames:''
	poolDictionaries:''
	category:'Monticello-Modeling'
!


!MCScriptDefinition class methodsFor:'as yet unclassified'!

from: aPackageInfo
	^ self script: (aPackageInfo perform: self scriptSelector) contents asString packageName: aPackageInfo name
!

script: aString packageName: packageString
	^ self instanceLike: (self new initializeWithScript: aString packageName: packageString)
!

scriptSelector
	self subclassResponsibility
! !

!MCScriptDefinition methodsFor:'as yet unclassified'!

= aDefinition
	^ (super = aDefinition)
		and: [script = aDefinition script]
!

accept: aVisitor
	"do nothing for now - this means it won't appear in the .st file"
!

description
	^ Array with: packageName with: self scriptSelector
!

evaluate
	Compiler evaluate: script
!

initializeWithScript: aString packageName: packageString
	script _ aString.
	packageName _ packageString
!

installScript
	self installScript: script
!

installScript: aString
	self packageInfo perform: (self scriptSelector, ':') asSymbol with: aString
!

load
	self installScript
!

packageInfo
	^ PackageInfo named: packageName
!

script
	^ script
!

scriptSelector
	^ self class scriptSelector
!

sortKey
	^ '<', self scriptSelector, '>'
!

source
	^ script
!

summary
	^ packageName, ' ', self scriptSelector
!

unload
	self installScript: nil
! !

!MCScriptDefinition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCScriptDefinition.st,v 1.1 2006-11-22 13:10:11 cg Exp $'
! !
